package org.dromara.zhishu.service;

import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.zhishu.domain.TFreight;
import org.dromara.zhishu.domain.bo.TFreightBo;
import org.dromara.zhishu.domain.vo.TFreightVo;
import org.dromara.zhishu.domain.vo.TShelvesVo;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 三级货区管理Service接口
 *
 * @author Lion Li
 * @date 2025-04-19
 */
public interface ITFreightService {

    List<Map> selectDepotTree();

    /**
     * 根据二级货区id获取三级货区
     * @param shelvesId
     * @return
     */
    List<TFreightVo> selectByShelvesId(Long shelvesId);

    /**
     * 根据货区id获取 一级二级三级货区的编号和id
     * @param freightId
     * @return
     */
    Map selectByFreightId(Long freightId);
    /**
     * 查询三级货区管理
     *
     * @param id 主键
     * @return 三级货区管理
     */
    TFreightVo queryById(Long id);

    /**
     * 分页查询三级货区管理列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 三级货区管理分页列表
     */
    TableDataInfo<TFreightVo> queryPageList(TFreightBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的三级货区管理列表
     *
     * @param bo 查询条件
     * @return 三级货区管理列表
     */
    List<TFreightVo> queryList(TFreightBo bo);

    /**
     * 新增三级货区管理
     *
     * @param bo 三级货区管理
     * @return 是否新增成功
     */
    TFreightBo insertByBo(TFreightBo bo);

    /**
     * 修改三级货区管理
     *
     * @param bo 三级货区管理
     * @return 是否修改成功
     */
    Boolean updateByBo(TFreightBo bo);

    /**
     * 校验并批量删除三级货区管理信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid,Long LocalUserId);

    List<TShelvesVo> querySheNameList();

    /**
     * 根据三级获取名称获取获取信息
     * @param freightName
     * @param shelvesId
     * @return
     */
    TFreightVo selectByFreightName(String freightName, Long shelvesId);
}
